import asyncio

from cpl_core.application import ApplicationABC
from cpl_core.application import ApplicationBuilder

from startup_test_extension import StartupTestExtension
from ui_tests.startup import Startup
from ui_tests_shared.declarations import Declarations

try:
    from test_application import TestApplication
except ImportError:
    from .test_application import TestApplication


def get_app() -> ApplicationABC:
    app_builder = ApplicationBuilder(TestApplication) \
        .use_extension(StartupTestExtension) \
        .use_startup(Startup)
    app = app_builder.build()
    Declarations.app = app
    return app


async def main():
    app = get_app()
    await app.run_async()


if __name__ == '__main__':
    import nest_asyncio

    nest_asyncio.apply()
    asyncio.run(main())
